{*********************************************************}
{*          Web server application components            *}
{*                     version 2.0                       *}
{*         Copyright (c) 2000-2002  S.Perevoznyk         *}
{*                 All rights reserved.                  *}
{*********************************************************}
unit psvTags;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, math,
  HTTPAPP, {$IFDEF VER140}HTTPProd,{$ENDIF} psvWeb;

type
  TWebLibrary = class(TpsvCustomTagLib)
  protected
    //info
    procedure Author(Sender: TObject; Tag: TTag; const TagString: string;
    TagParams: TStrings; var ReplaceText: string);

    // string functions

    procedure IUpperCase(Sender: TObject; Tag: TTag; const TagString: string;
    TagParams: TStrings; var ReplaceText: string);

    procedure ILowerCase(Sender: TObject; Tag: TTag; const TagString: string;
    TagParams: TStrings; var ReplaceText: string);

    //Match functions

    procedure IABS(Sender: TObject; Tag: TTag; const TagString: string;
    TagParams: TStrings; var ReplaceText: string);

    procedure ICEIL(Sender: TObject; Tag: TTag; const TagString: string;
     TagParams: TStrings; var ReplaceText: string);

    procedure IRND(Sender: TObject; Tag: TTag; const TagString: string;
     TagParams: TStrings; var ReplaceText: string);

    procedure ITRUNC(Sender: TObject; Tag: TTag; const TagString: string;
     TagParams: TStrings; var ReplaceText: string);


  public
    constructor Create(AOwner : TComponent); override;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('FastWeb', [TWebLibrary]);
end;

{$IFDEF VER130}
function StrToFloatDef(const S: string; const Default: Extended): Extended;
begin
  if not TextToFloat(PChar(S), Result, fvExtended) then
    Result := Default;
end;
{$ENDIF}

{ TpsvIWebTagLib }

constructor TWebLibrary.Create(AOwner: TComponent);
var
  TagItem : TpsvTagItem;
begin
  inherited;

  TagItem := Tags.Add;
  TagItem.TagName := 'AUTHOR';
  TagItem.OnHTMLTag := Author;

  TagItem := Tags.Add;
  TagItem.TagName := 'ILOWERCASE';
  TagItem.OnHTMLTag := ILowerCase;

  TagItem := Tags.Add;
  TagItem.TagName := 'IUPPERCASE';
  TagItem.OnHTMLTag := IUpperCase;

  TagItem := Tags.Add;
  TagItem.TagName := 'IABS';
  TagItem.OnHTMLTag := Iabs;

  TagItem := Tags.Add;
  TagItem.TagName := 'ITRUNC';
  TagItem.OnHTMLTag := ITRUNC;

  TagItem := Tags.Add;
  TagItem.TagName := 'IRND';
  TagItem.OnHTMLTag := IRND;

  TagItem := Tags.Add;
  TagItem.TagName := 'ICEIL';
  TagItem.OnHTMLTag := ICEIL;

end;

procedure TWebLibrary.Author(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
begin
  ReplaceText := '<a href="mailto:serge_perevoznyk@hotmail.com">Serhiy Perevoznyk</a>';
end;

procedure TWebLibrary.ILowerCase(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
begin
  ReplaceText := LowerCase(TagParams.Values['Value']);
end;

procedure TWebLibrary.IUpperCase(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
begin
  ReplaceText := UpperCase(TagParams.Values['Value']);
end;

procedure TWebLibrary.IABS(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
begin
   ReplaceText := IntToStr(Abs(StrToIntDef(TagParams.Values['Value'],0)));
end;

procedure TWebLibrary.ICEIL(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
begin
  ReplaceText := IntToStr(Ceil(StrToFloatDef(TagParams.Values['Value'],0)));
end;

procedure TWebLibrary.IRND(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
begin
  ReplaceText := IntToStr(Round(StrToFloatDef(TagParams.Values['Value'],0)));
end;

procedure TWebLibrary.ITRUNC(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
begin
  ReplaceText := IntToStr(Trunc(StrToFloatDef(TagParams.Values['Value'],0)));
end;

end.
